function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import ImportRemoverTransformer from './ImportTransformer';
import { getSucraseContext, RootTransformer } from './parser';
import wrapLastExpression from './wrapLastExpression';

class JarleRootTransformer extends RootTransformer {
  constructor(context, options, parsingTransforms) {
    var _options$transforms;

    super(context, (_options$transforms = options.transforms) !== null && _options$transforms !== void 0 ? _options$transforms : [], false, _objectSpread({}, options));

    _defineProperty(this, "importTransformer", void 0);

    _defineProperty(this, "wrapLastExpression", void 0);

    this.importTransformer = new ImportRemoverTransformer(context, options); // @ts-ignore

    this.transformers.unshift(this.importTransformer);
    this.wrapLastExpression = options.wrapLastExpression ? result => {
      return wrapLastExpression(getSucraseContext(result, _objectSpread(_objectSpread({}, options), {}, {
        transforms: parsingTransforms
      })));
    } : result => result;
  }

  get imports() {
    return this.importTransformer.imports;
  }

  transform() {
    let result = super.transform();
    result = result.replace('"use strict";', '').replace('exports. default =', 'exports.default =').replace('Object.defineProperty(exports, "__esModule", {value: true});', '');
    return this.wrapLastExpression(result);
  }

}

export function transform(code, options = {}) {
  const transforms = options.transforms || [];
  const parsingTransforms = ['imports', 'jsx'];
  const isTypeScriptEnabled = options.syntax === 'typescript' || transforms.includes('typescript');

  if (isTypeScriptEnabled) {
    parsingTransforms.push('typescript');
  }

  const sucraseOptions = _objectSpread(_objectSpread({}, options), {}, {
    transforms,
    preserveDynamicImport: true,
    enableLegacyBabel5ModuleInterop: false,
    enableLegacyTypeScriptModuleInterop: true,
    jsxRuntime: 'classic'
  });

  const ctx = getSucraseContext(code, _objectSpread(_objectSpread({}, sucraseOptions), {}, {
    transforms: parsingTransforms
  }));
  const transformer = new JarleRootTransformer(ctx, sucraseOptions, parsingTransforms);
  return {
    code: transformer.transform(),
    imports: transformer.imports
  };
}