import { Language, PrismTheme } from 'prism-react-renderer';
import React from 'react';
import { LineOutputProps } from './prism';
declare type MapTokens = Omit<LineOutputProps, 'props'> & {
    getLineNumbers?: (line: number) => React.ReactNode;
    errorLocation?: {
        line: number;
        col: number;
    };
};
export declare const mapTokens: ({ tokens, getLineProps, getTokenProps, errorLocation, getLineNumbers, }: MapTokens) => JSX.Element;
interface Props {
    className?: string;
    style?: any;
    theme?: PrismTheme;
    code: string;
    language: Language;
    lineNumbers?: boolean;
}
declare function CodeBlock({ code, theme, language, lineNumbers, ...props }: Props): JSX.Element;
export default CodeBlock;
