import { SucraseContext } from 'sucrase';
import { TokenProcessor, CJSImportProcessor } from './parser';
export declare type Import = {
    code: string;
    source: string;
    base: null | string;
    keys: Array<{
        local: string;
        imported: string;
    }>;
};
export default class ImportRemoverTransformer {
    tokens: TokenProcessor;
    importProcessor: CJSImportProcessor;
    imports: Import[];
    private readonly removeImports;
    constructor(context: SucraseContext, { removeImports }: {
        removeImports?: boolean;
    });
    getPrefixCode(): string;
    getHoistedCode(): string;
    getSuffixCode(): string;
    process(): boolean;
    num: number;
    getIdentifier(src: string): string;
    private buildImport;
}
