"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _transform = require("./transform");

var _default = (input, {
  inline: _inline = false,
  isTypeScript,
  showImports
} = {}) => {
  let {
    code,
    imports
  } = (0, _transform.transform)(input, {
    removeImports: !showImports,
    wrapLastExpression: _inline,
    transforms: isTypeScript ? ['typescript', 'jsx'] : ['jsx'],
    compiledFilename: 'compiled.js',
    filename: 'example.js'
  });
  return {
    code,
    imports
  };
};

exports.default = _default;